; MODULE "EXTRA" FOR "MICRO BUG"
; (XMAS 1996 PRELIMINAR RELEASE: COMMANDS "S" AND "U")
;
; AUTHOR: EINAR GATTONI SAUKAS


; unused area

6E00  00           NOP
...
76FF  00           NOP


; command U (display memory blocks and sums)

7700  AF           XOR A        ; print space
7701  D7           RST 10
7702  CD 52 7A     CALL 7A52    ; $CURSOR
7705  B7           OR A         ; 1st parameter?
7706  28 07        JR Z,770F
7708  CD 9E 7A     CALL 7A9E    ; $VALDE
770B  EB           EX DE,HL     ; new address
770C  22 FA 77     LD (77FA),HL ; U-ADDRESS
770F  CD 60 78     CALL 7860    ; $SCRUP
7712  CD 25 77     CALL 7725    ; $AVNU
7715  CD D3 78     CALL 78D3    ; $KEY
7718  B7           OR A         ; return if BREAK
7719  C8           RET Z
771A  FE 30        CP 30        ; forward if "K"
771C  28 F4        JR Z,7712
771E  FE 2F        CP 2F        ; backward if "J"
7720  CC 6C 77     CALL Z,776C  ; $RTRU
7723  18 F0        JR 7715


; routine $AVNU (forward for command U)

7725  2A FA 77     LD HL,(77FA) ; U-ADDRESS
7728  01 08 00     LD BC,0008
772B  E5           PUSH HL
772C  09           ADD HL,BC    ; update U-ADDRESS
772D  22 FA 77     LD (77FA),HL ; U-ADDRESS
7730  E1           POP HL
7731  CD 60 78     CALL 7860    ; $SCRUP
7734  E5           PUSH HL
7735  AF           XOR A        ; "hack" $AVND
7736  32 FD 7C     LD (7CFD),A
7739  32 0C 7D     LD (7D0C),A
773C  CD EC 7C     CALL 7CEC    ; inside $AVND
773F  3E D7        LD A,D7      ; "fix" $AVND
7741  32 FD 7C     LD (7CFD),A
7744  32 0C 7D     LD (7D0C),A
7747  E1           POP HL
7748  11 08 00     LD DE,0008
774B  AF           XOR A        ; print space
774C  D7           RST 10
774D  47           LD B,A       ; calculate sum
774E  4F           LD C,A
774F  E5           PUSH HL
7750  19           ADD HL,DE
7751  22 33 79     LD (7933),HL ; 2ND-PARAM
7754  E1           POP HL
7755  CD C9 7F     CALL 7FC9    ; $SOMA
7758  21 39 7B     LD HL,7B39   ; "hack" $ENDER
775B  36 18        LD (HL),18
775D  E5           PUSH HL
775E  60           LD H,B       ; print sum
775F  69           LD L,C
7760  3A 26 79     LD A,(7926)  ; MFLAG
7763  CB 6F        BIT 5,A
7765  CD 0C 7B     CALL 7B0C    ; inside $ENDER
7768  E1           POP HL       ; "fix" $ENDER
7769  36 2A        LD (HL),2A
776B  C9           RET


; routine $RTRU (backward for command U)

776C  2A FA 77     LD HL,(77FA) ; U-ADDRESS
776F  11 08 00     LD DE,0008
7772  A7           AND A        ; update U-ADDRESS
7773  ED 52        SBC HL,DE
7775  22 FA 77     LD (77FA),HL ; U-ADDRESS
7778  1E B0        LD E,B0      ; calculate address
777A  A7           AND A
777B  ED 52        SBC HL,DE
777D  CD 79 78     CALL 7879    ; $SCRDN
7780  18 B2        JR 7734      ; inside $AVNU


; routine $AVNS (forward for command S)

7782  2A FC 77     LD HL,(77FC) ; S-ADDRESS
7785  E5           PUSH HL
7786  ED 5B FE 77  LD DE,(77FE) ; S-STEP
778A  19           ADD HL,DE    ; update S-ADDRESS
778B  22 FC 77     LD (77FC),HL ; S-ADDRESS
778E  E1           POP HL
778F  CD 60 78     CALL 7860    ; $SCRUP
7792  CD 02 7B     CALL 7B02    ; $ENDER
7795  3E 16        LD A,16      ; print "->"
7797  D7           RST 10
7798  3E 12        LD A,12
779A  D7           RST 10
779B  ED 5B FE 77  LD DE,(77FE) ; S-STEP
779F  18 AA        JR 774B      ; inside $AVNU


; routine $RTRS (backward for command S)

77A1  2A FC 77     LD HL,(77FC) ; S-ADDRESS
77A4  ED 5B FE 77  LD DE,(77FE) ; S-STEP
77A8  A7           AND A        ; update S-ADDRESS
77A9  ED 52        SBC HL,DE
77AB  22 FC 77     LD (77FC),HL ; S-ADDRESS
77AE  06 16        LD B,16      ; calculate address
77B0  A7           AND A
77B1  ED 52        SBC HL,DE
77B3  10 FB        DJNZ 77B0
77B5  CD 79 78     CALL 7879    ; $SCRDN
77B8  18 D8        JR 7792      ; inside $AVNS


; command S (display memory sums)

77BA  AF           XOR A        ; print space
77BB  D7           RST 10
77BC  CD 52 7A     CALL 7A52    ; $CURSOR
77BF  B7           OR A         ; 1st parameter?
77C0  28 12        JR Z,77D4
77C2  CD 9E 7A     CALL 7A9E    ; $VALDE
77C5  ED 53 FC 77  LD (77FC),DE ; S-ADDRESS
77C9  B7           OR A         ; 2nd parameter?
77CA  28 08        JR Z,77D4
77CC  23           INC HL
77CD  CD A7 7A     CALL 7AA7    ; inside $VALDE
77D0  ED 53 FE 77  LD (77FE),DE ; S-STEP
77D4  CD 60 78     CALL 7860    ; $SCRUP
77D7  CD 82 77     CALL 7782    ; $AVNS
77DA  CD D3 78     CALL 78D3    ; $KEY
77DD  B7           OR A         ; return if BREAK
77DE  C8           RET Z
77DF  FE 30        CP 30        ; forward if "K"
77E1  28 F4        JR Z,77D7
77E3  FE 2F        CP 2F        ; backward if "J"
77E5  CC A1 77     CALL Z,77A1  ; $RTRS
77E8  18 F0        JR 77DA


; unused area
                         
77EA  00           NOP
77EB  00           NOP
77EC  00           NOP
77ED  00           NOP
77EE  00           NOP
77EF  00           NOP
77F0  00           NOP
77F1  00           NOP
77F2  00           NOP
77F3  00           NOP
77F4  00           NOP
77F5  00           NOP
77F6  00           NOP
77F7  00           NOP
77F8  00           NOP
77F9  00           NOP


; data area

77FA  00 00        ; value of U-ADDRESS
77FC  00 00        ; value of S-ADDRESS
77FE  08 00        ; value of S-STEP


; TCM: module commands table

7800  BA 77        ; command S
7802  34 7A        ; command T
7804  00 77        ; command U
7806  34 7A        ; command V
7808  34 7A        ; command W
780A  34 7A        ; command X
780C  34 7A        ; command Y
780E  34 7A        ; command Z


; routine $MORG (organize implementation of operating module)

7810  01 00 12     LD BC,1200
7813  CD F5 08     CALL 08F5
7816  CD C7 78     CALL 78C7
7819  32 1B 2A 3D  print "M.EXTRA (EINAR)"
      39 37 26 00
      10 2A 2E 33
      26 37 91
7828  21 00 78     LD HL,7800
782B  11 64 79     LD DE,7964
782E  06 10        LD B,10
7830  7E           LD A,(HL)
7831  12           LD (DE),A
7832  23           INC HL
7833  13           INC DE
7834  10 FA        DJNZ 7830
7836  CD E3 79     CALL 79E3
7839  C9           RET
783A  CA 8C        ; sum "P 6E00,783A"

; END OF LISTING - This is part of TKPAK001.ZIP and cannot be sold separately!

