; PROJECT "MICRO BUG - SISTEMA GERENCIADOR DE MODULOS"
; COORD. RENATO DEGIOVANI - BRASIL - 1984
; (C) ATI-EDITORA - "REVISTA MICRO SISTEMAS"
;
; CONVERTED BY EINAR GATTONI SAUKAS - BRASIL - 1996


; memory area reserved for module code

6E00  00           NOP
...
77FF  00           NOP


; TCM: module commands table

7800  34 7A        ; command S
7802  34 7A        ; command T
7804  34 7A        ; command U
7806  34 7A        ; command V
7808  34 7A        ; command W
780A  34 7A        ; command X
780C  34 7A        ; command Y
780E  34 7A        ; command Z


; routine $MORG (organize implementation of operating module)

7810  01 00 12     LD BC,1200
7813  CD F5 08     CALL 08F5
7816  CD C7 78     CALL 78C7
7819  00 00 00 00  print module name
      00 00 00 00
      00 00 00 00
      00 00 80
7828  21 00 78     LD HL,7800
782B  11 64 79     LD DE,7964
782E  06 10        LD B,10
7830  7E           LD A,(HL)
7831  12           LD (DE),A
7832  23           INC HL
7833  13           INC DE
7834  10 FA        DJNZ 7830
7836  CD E3 79     CALL 79E3
7839  C9           RET
783A  00 00        ; reserved for module sum
783C  00           NOP


; safety byte

783D  C9           RET


; routine $BYTE (print hex value)

783E  F5           PUSH AF
783F  1F           RRA
7840  1F           RRA
7841  1F           RRA
7842  1F           RRA
7843  CD 47 78     CALL 7847
7846  F1           POP AF
7847  F5           PUSH AF
7848  E6 0F        AND 0F
784A  E5           PUSH HL
784B  21 27 79     LD HL,7927   ; SFLAG
784E  CB 46        BIT 0,(HL)
7850  E1           POP HL
7851  20 09        JR NZ,785C
7853  CB 5F        BIT 3,A
7855  28 02        JR Z,7859
7857  EE 88        XOR 88
7859  D7           RST 10
785A  F1           POP AF
785B  C9           RET
785C  C6 1C        ADD A,1C
785E  18 F9        JR 7859


; routine $SCRUP (scroll up)

7860  E5           PUSH HL
7861  2A 0C 40     LD HL,(400C)
7864  E5           PUSH HL
7865  11 21 00     LD DE,0021
7868  19           ADD HL,DE
7869  D1           POP DE
786A  01 D6 02     LD BC,02D6
786D  ED B0        LDIR
786F  0E 41        LD C,41
7871  A7           AND A
7872  ED 42        SBC HL,BC
7874  22 0E 40     LD (400E),HL
7877  E1           POP HL
7878  C9           RET


; routine $SCRDN (scroll down)

7879  E5           PUSH HL
787A  2A 0C 40     LD HL,(400C)
787D  E5           PUSH HL
787E  01 B4 02     LD BC,02B4
7881  09           ADD HL,BC
7882  11 21 00     LD DE,0021
7885  E5           PUSH HL
7886  19           ADD HL,DE
7887  D1           POP DE
7888  EB           EX DE,HL
7889  ED B8        LDDR
788B  AF           XOR A
788C  06 20        LD B,20
788E  23           INC HL
788F  77           LD (HL),A
7890  10 FC        DJNZ 788E
7892  E1           POP HL
7893  23           INC HL
7894  18 DE        JR 7874


; routine $CONTROL (manipulate MFLAG)

7896  D6 DE        SUB DE
7898  47           LD B,A
7899  0E 01        LD C,01
789B  28 04        JR Z,78A1
789D  CB 11        RL C
789F  10 FC        DJNZ 789D
78A1  3A 26 79     LD A,(7926)  ; MFLAG
78A4  A9           XOR C
78A5  32 26 79     LD (7926),A  ; MFLAG
78A8  3E FF        LD A,FF


; routine $CONT (wait keyboard release)

78AA  F5           PUSH AF
78AB  CD BB 02     CALL 02BB
78AE  7C           LD A,H
78AF  FE FE        CP FE
78B1  38 F8        JR C,78AB
78B3  06 03        LD B,03
78B5  18 03        JR 78BA


; routine $TEMPO (delay execution)

78B7  F5           PUSH AF
78B8  06 18        LD B,18
78BA  AF           XOR A
78BB  0B           DEC BC
78BC  B8           CP B
78BD  20 FC        JR NZ,78BB
78BF  F1           POP AF
78C0  C9           RET


; routine $PRINT (print strings)

78C1  CD 60 78     CALL 7860    ; $SCRUP
78C4  CD 60 78     CALL 7860    ; $SCRUP
78C7  E1           POP HL
78C8  7E           LD A,(HL)
78C9  E6 7F        AND 7F
78CB  D7           RST 10
78CC  CB 7E        BIT 7,(HL)
78CE  23           INC HL
78CF  E5           PUSH HL
78D0  C0           RET NZ
78D1  18 F4        JR 78C7


; routine $KEY (read keyboard)

78D3  CD BB 02     CALL 02BB
78D6  7C           LD A,H
78D7  FE FE        CP FE
78D9  30 F8        JR NC,78D3
78DB  44           LD B,H
78DC  4D           LD C,L
78DD  CD BD 07     CALL 07BD
78E0  7E           LD A,(HL)
78E1  FE 76        CP 76
78E3  C8           RET Z
78E4  FE 77        CP 77
78E6  C8           RET Z
78E7  FE C0        CP C0
78E9  28 1D        JR Z,7908    ; $CLS
78EB  FE 74        CP 74
78ED  28 24        JR Z,7913    ; $GRAPH
78EF  FE DE        CP DE
78F1  D4 96 78     CALL NC,7896 ; $CONTROL
78F4  FE 75        CP 75
78F6  CA EE 79     JP Z,79EE
78F9  FE DD        CP DD
78FB  CC 69 08     CALL Z,0869
78FE  00           NOP
78FF  00           NOP
7900  00           NOP
7901  00           NOP
7902  00           NOP
7903  CB 77        BIT 6,A
7905  C8           RET Z
7906  18 CB        JR 78D3


; routine $CLS (clear screen)

7908  CD 2A 0A     CALL 0A2A
790B  01 01 15     LD BC,1501
790E  CD F5 08     CALL 08F5
7911  18 C0        JR 78D3      ; $KEY


; routine $GRAPH (GRAPHICS mode of $CURSOR)

7913  3A 27 79     LD A,(7927)  ; SFLAG
7916  EE 10        XOR 10
7918  32 27 79     LD (7927),A  ; SFLAG
791B  18 B6        JR 78D3      ; $KEY


; command B (return to BASIC)

791D  CD C7 78     CALL 78C7    ; $PRINT (no $SCRUP)
7920  26 38 2E A8  ; print "ASIC"
7924  E1           POP HL
7925  C9           RET


; data buffer

7926  00           ; value of MFLAG
7927  01           ; value of SFLAG
7928  00 00        ; address of BREAKPOINT
792A  00 00 00     ; bytes replaced by BREAKPOINT
792D  EF 40        ; value of M-ADDRESS
792F  22 41        ; value of D-ADDRESS
7931  00 78        ; value of 1ST-PARAM
7933  FF 7F        ; value of 2ND-PARAM
7935  20           ; value of 3RD-PARAM
7936  00 00        ; value of AF
7938  E2 EA        ; value of HL
793A  00 00        ; value of DE
793C  00 00        ; value of BC
793E  EA 6D        ; value of SP


; commands definition table

7940  4C 7D        ; command A
7942  1D 79        ; command B
7944  86 7F        ; command C
7946  27 7D        ; command D
7948  15 7C        ; command E
794A  3C 7E        ; command F
794C  38 7F        ; command G
794E  E8 7D        ; command H
7950  04 7F        ; command I
7952  0D 7F        ; command J
7954  23 7F        ; command K
7956  15 7F        ; command L
7958  7B 7B        ; command M
795A  9E 7D        ; command N
795C  9C 7C        ; command O
795E  D6 7F        ; command P
7960  34 7A        ; command Q
7962  34 7A        ; command R
7964  34 7A        ; command S
7966  34 7A        ; command T
7968  34 7A        ; command U
796A  34 7A        ; command V
796C  34 7A        ; command W
796E  34 7A        ; command X
7970  34 7A        ; command Y
7972  34 7A        ; command Z


; data area (MICROBUG logo)

7974  B0 F4 BB B0
      BB 4F BB 40
      BB 40 FB B4
      F4 0B 0B B4
      9A 84 08 0D
      50 3F 50 8D
      50 80 F5 08
      D5 08 D5 03
      82 D5 08 0D
      50 0D 78 1D
      50 80 D7 3A
      D5 08 D5 FB
      80 D5 B8 B2
      AB 7D 52 A2
      AB 70 DA B7
      2A B7 2A B7


; routine ??? (print MICROBUG logo)

79B4  CD 2A 0A     CALL 0A2A
79B7  21 27 79     LD HL,7927   ; SFLAG
79BA  CB 86        RES 0,(HL)
79BC  2E 74        LD L,74
79BE  06 40        LD B,40
79C0  7E           LD A,(HL)
79C1  CD 3E 78     CALL 783E    ; $BYTE
79C4  23           INC HL
79C5  10 F9        DJNZ 79C0
79C7  2E 27        LD L,27
79C9  CB C6        SET 0,(HL)
79CB  CD C7 78     CALL 78C7    ; $PRINT (no $SCRUP)
79CE  32 2E 28 37  ; print "MICRO SISTEMAS *1984*"
      34 00 38 2E
      38 39 2A 32
      26 38 00 17
      1D 25 24 20
      97
79E3  01 00 15     LD BC,1500
79E6  CD F5 08     CALL 08F5
79E9  C9           RET


; Command loop

79EA  ED 73 3E 79  LD (793E),SP
79EE  CD B4 79     CALL 79B4
79F1  CD 2B 0F     CALL 0F2B
79F4  21 27 79     LD HL,7927   ; SFLAG
79F7  CB 56        BIT 2,(HL)
79F9  C4 10 78     CALL NZ,7810 ; $MORG
79FC  ED 7B 3E 79  LD SP,(793E)
7A00  3E 12        LD A,12
7A02  D7           RST 10
7A03  2A 0E 40     LD HL,(400E)
7A06  36 04        LD (HL),04
7A08  CD AA 78     CALL 78AA    ; $CONT
7A0B  CD D3 78     CALL 78D3    ; $KEY
7A0E  FE 77        CP 77
7A10  28 F6        JR Z,7A08
7A12  FE 76        CP 76
7A14  28 F2        JR Z,7A08
7A16  D7           RST 10
7A17  CD AA 78     CALL 78AA    ; $CONT
7A1A  D6 26        SUB 26
7A1C  38 16        JR C,7A34
7A1E  FE 1A        CP 1A
7A20  3F           CCF
7A21  38 11        JR C,7A34
7A23  17           RLA
7A24  06 00        LD B,00
7A26  4F           LD C,A
7A27  21 40 79     LD HL,7940
7A2A  09           ADD HL,BC
7A2B  5E           LD E,(HL)
7A2C  23           INC HL
7A2D  56           LD D,(HL)
7A2E  21 4A 7A     LD HL,7A4A
7A31  E5           PUSH HL
7A32  D5           PUSH DE
7A33  C9           RET
7A34  CD C1 78     CALL 78C1    ; $PRINT
7A37  28 34 32 26  ; print "COMANDO INEXISTENTE"
      33 29 34 00
      2E 33 2A 3D
      2E 38 39 2A
      33 39 AA
7A4A  CD 60 78     CALL 7860    ; $SCRUP
7A4D  CD 60 78     CALL 7860    ; $SCRUP
7A50  18 AA        JR 79FC


; routine $CURSOR (organize data input)

7A52  2A 0E 40     LD HL,(400E)
7A55  36 04        LD (HL),04
7A57  CD AA 78     CALL 78AA    ; $CONT
7A5A  CD D3 78     CALL 78D3    ; $KEY
7A5D  2A 0E 40     LD HL,(400E)
7A60  36 00        LD (HL),00
7A62  2B           DEC HL
7A63  FE 76        CP 76
7A65  20 02        JR NZ,7A69
7A67  7E           LD A,(HL)
7A68  C9           RET
7A69  FE 77        CP 77
7A6B  20 1A        JR NZ,7A87
7A6D  7E           LD A,(HL)
7A6E  FE 76        CP 76
7A70  22 0E 40     LD (400E),HL
7A73  20 24        JR NZ,7A99
7A75  CD C1 78     CALL 78C1    ; $PRINT
7A78  29 2A 31 2A  ; print "DELETE ILEGAL"
      39 2A 00 2E
      31 2A 2C 26
      B1
7A85  18 C3        JR 7A4A
7A87  E5           PUSH HL
7A88  21 27 79     LD HL,7927   ; SFLAG
7A8B  CB 66        BIT 4,(HL)
7A8D  E1           POP HL
7A8E  28 02        JR Z,7A92
7A90  CB FF        SET 7,A
7A92  D7           RST 10
7A93  23           INC HL
7A94  23           INC HL
7A95  7E           LD A,(HL)
7A96  FE 76        CP 76
7A98  C8           RET Z
7A99  CD AA 78     CALL 78AA    ; $CONT
7A9C  18 B4        JR 7A52


; routine $VALDE (identify a numeric value)

7A9E  01 03 15     LD BC,1503
7AA1  CD F5 08     CALL 08F5
7AA4  2A 0E 40     LD HL,(400E)
7AA7  11 00 00     LD DE,0000
7AAA  7E           LD A,(HL)
7AAB  FE 0D        CP 0D
7AAD  28 2D        JR Z,7ADC
7AAF  00           NOP
7AB0  7E           LD A,(HL)
7AB1  B7           OR A
7AB2  C8           RET Z
7AB3  FE 1A        CP 1A
7AB5  C8           RET Z
7AB6  D6 1C        SUB 1C
7AB8  38 10        JR C,7ACA
7ABA  FE 10        CP 10
7ABC  30 0C        JR NC,7ACA
7ABE  EB           EX DE,HL
7ABF  06 04        LD B,04
7AC1  29           ADD HL,HL
7AC2  10 FD        DJNZ 7AC1
7AC4  4F           LD C,A
7AC5  09           ADD HL,BC
7AC6  EB           EX DE,HL
7AC7  23           INC HL
7AC8  18 E6        JR 7AB0
7ACA  CD C1 78     CALL 78C1    ; $PRINT
7ACD  29 2E 2C 2E  ; print "DIGITO ILEGAL"
      39 34 00 2E
      31 2A 2C 26
      B1
7ADA  18 A9        JR 7A85
7ADC  23           INC HL
7ADD  7E           LD A,(HL)
7ADE  B7           OR A
7ADF  C8           RET Z
7AE0  FE 1A        CP 1A
7AE2  C8           RET Z
7AE3  D6 1C        SUB 1C
7AE5  38 E3        JR C,7ACA
7AE7  FE 0A        CP 0A
7AE9  30 DF        JR NC,7ACA
7AEB  E5           PUSH HL
7AEC  F5           PUSH AF
7AED  21 00 00     LD HL,0000
7AF0  3E 0A        LD A,0A
7AF2  06 08        LD B,08
7AF4  29           ADD HL,HL
7AF5  17           RLA
7AF6  30 01        JR NC,7AF9
7AF8  19           ADD HL,DE
7AF9  10 F9        DJNZ 7AF4
7AFB  F1           POP AF
7AFC  4F           LD C,A
7AFD  09           ADD HL,BC
7AFE  EB           EX DE,HL
7AFF  E1           POP HL
7B00  18 DA        JR 7ADC


; routine $ENDER (print memory address)

7B02  3A 26 79     LD A,(7926)  ; MFLAG
7B05  CB 5F        BIT 3,A
7B07  CC B7 78     CALL Z,78B7  ; $TEMPO
7B0A  CB 57        BIT 2,A
7B0C  20 0D        JR NZ,7B1B
7B0E  7C           LD A,H
7B0F  CD 3E 78     CALL 783E    ; $BYTE
7B12  7D           LD A,L
7B13  CD 3E 78     CALL 783E    ; $BYTE
7B16  AF           XOR A
7B17  D7           RST 10
7B18  D7           RST 10
7B19  D7           RST 10
7B1A  C9           RET
7B1B  E5           PUSH HL
7B1C  1E FF        LD E,FF
7B1E  01 F0 D8     LD BC,D8F0
7B21  CD E1 07     CALL 07E1
7B24  01 18 FC     LD BC,FC18
7B27  CD E1 07     CALL 07E1
7B2A  01 9C FF     LD BC,FF9C
7B2D  CD E1 07     CALL 07E1
7B30  0E F6        LD C,F6
7B32  CD E1 07     CALL 07E1
7B35  7D           LD A,L
7B36  CD EB 07     CALL 07EB
7B39  2A 0E 40     LD HL,(400E)
7B3C  06 09        LD B,09
7B3E  7E           LD A,(HL)
7B3F  05           DEC B
7B40  2B           DEC HL
7B41  FE 76        CP 76
7B43  20 F9        JR NZ,7B3E
7B45  AF           XOR A
7B46  D7           RST 10
7B47  10 FD        DJNZ 7B46
7B49  E1           POP HL
7B4A  C9           RET


; routine ??? (forward for command M)

7B4B  2A 2D 79     LD HL,(792D) ; M-ADDRESS
7B4E  23           INC HL
7B4F  22 2D 79     LD (792D),HL ; M-ADDRESS
7B52  CD 60 78     CALL 7860    ; $SCRUP
7B55  CD 02 7B     CALL 7B02    ; $ENDER
7B58  7E           LD A,(HL)
7B59  21 26 79     LD HL,7926   ; MFLAG
7B5C  CB 46        BIT 0,(HL)
7B5E  20 03        JR NZ,7B63
7B60  C3 3E 78     JP 783E      ; $BYTE
7B63  4F           LD C,A
7B64  AF           XOR A
7B65  47           LD B,A
7B66  C3 98 0A     JP 0A98


; routine ??? (backward for command M)

7B69  2A 2D 79     LD HL,(792D) ; M-ADDRESS
7B6C  2B           DEC HL
7B6D  22 2D 79     LD (792D),HL ; M-ADDRESS
7B70  01 15 00     LD BC,0015
7B73  A7           AND A
7B74  ED 42        SBC HL,BC
7B76  CD 79 78     CALL 7879    ; $SCRDN
7B79  18 DA        JR 7B55


; command M (memory edit)

7B7B  AF           XOR A
7B7C  D7           RST 10
7B7D  CD 52 7A     CALL 7A52    ; $CURSOR
7B80  B7           OR A
7B81  28 08        JR Z,7B8B
7B83  CD 9E 7A     CALL 7A9E    ; $VALDE
7B86  EB           EX DE,HL
7B87  2B           DEC HL
7B88  22 2D 79     LD (792D),HL ; M-ADDRESS
7B8B  CD 60 78     CALL 7860    ; $SCRUP
7B8E  CD 4B 7B     CALL 7B4B
7B91  CD D3 78     CALL 78D3    ; $KEY
7B94  B7           OR A
7B95  C8           RET Z
7B96  FE 30        CP 30
7B98  28 F4        JR Z,7B8E
7B9A  FE 1C        CP 1C
7B9C  38 F3        JR C,7B91
7B9E  FE 2C        CP 2C
7BA0  38 07        JR C,7BA9
7BA2  FE 2F        CP 2F
7BA4  CC 69 7B     CALL Z,7B69
7BA7  18 E8        JR 7B91
7BA9  F5           PUSH AF
7BAA  01 0B 15     LD BC,150B
7BAD  CD F5 08     CALL 08F5
7BB0  3A 26 79     LD A,(7926)  ; MFLAG
7BB3  CB 77        BIT 6,A
7BB5  20 29        JR NZ,7BE0
7BB7  F1           POP AF
7BB8  D7           RST 10
7BB9  CD AA 78     CALL 78AA    ; $CONT
7BBC  D6 1C        SUB 1C
7BBE  A7           AND A
7BBF  17           RLA
7BC0  17           RLA
7BC1  17           RLA
7BC2  17           RLA
7BC3  32 7B 40     LD (407B),A
7BC6  CD D3 78     CALL 78D3    ; $KEY
7BC9  FE 1C        CP 1C
7BCB  38 F9        JR C,7BC6
7BCD  FE 2C        CP 2C
7BCF  30 F5        JR NC,7BC6
7BD1  D7           RST 10
7BD2  D6 1C        SUB 1C
7BD4  FD 86 7B     ADD A,(IY+7B)
7BD7  2A 2D 79     LD HL,(792D) ; M-ADDRESS
7BDA  77           LD (HL),A
7BDB  CD AA 78     CALL 78AA    ; $CONT
7BDE  18 AE        JR 7B8E
7BE0  F1           POP AF
7BE1  D7           RST 10
7BE2  CD 52 7A     CALL 7A52    ; $CURSOR
7BE5  01 0B 15     LD BC,150B
7BE8  CD F5 08     CALL 08F5
7BEB  2A 0E 40     LD HL,(400E)
7BEE  11 00 00     LD DE,0000
7BF1  CD DD 7A     CALL 7ADD
7BF4  7B           LD A,E
7BF5  18 E0        JR 7BD7


; routine $ORG (organize command parameters)

7BF7  AF           XOR A
7BF8  D7           RST 10
7BF9  CD 52 7A     CALL 7A52    ; $CURSOR
7BFC  B7           OR A
7BFD  CA 4A 7A     JP Z,7A4A
7C00  CD 9E 7A     CALL 7A9E    ; $VALDE
7C03  ED 53 31 79  LD (7931),DE ; 1ST-PARAM
7C07  23           INC HL
7C08  CD A7 7A     CALL 7AA7
7C0B  ED 53 33 79  LD (7933),DE ; 2ND-PARAM
7C0F  23           INC HL
7C10  7E           LD A,(HL)
7C11  32 35 79     LD (7935),A  ; 3RD-PARAM
7C14  C9           RET


; command E (create REM line)

7C15  CD F7 7B     CALL 7BF7    ; $ORG
7C18  CD 23 0F     CALL 0F23
7C1B  2A 31 79     LD HL,(7931) ; 1ST-PARAM
7C1E  EB           EX DE,HL
7C1F  21 0F 27     LD HL,270F
7C22  A7           AND A
7C23  ED 52        SBC HL,DE
7C25  30 15        JR NC,7C3C
7C27  CD C1 78     CALL 78C1    ; $PRINT
7C2A  31 2E 33 2D  ; print "LINHA ILEGAL"
      26 00 2E 31
      2A 2C 26 B1
7C36  CD 2B 0F     CALL 0F2B
7C39  C3 4A 7A     JP 7A4A
7C3C  EB           EX DE,HL
7C3D  CD D8 09     CALL 09D8
7C40  20 14        JR NZ,7C56
7C42  CD C1 78     CALL 78C1    ; $PRINT
7C45  31 2E 33 2D  ; print "LINHA EXISTENTE"
      26 00 2A 3D
      2E 38 39 2A
      33 39 AA
7C54  18 E0        JR 7C36
7C56  E5           PUSH HL
7C57  2A 33 79     LD HL,(7933) ; 2ND-PARAM
7C5A  01 06 00     LD BC,0006
7C5D  09           ADD HL,BC
7C5E  E5           PUSH HL
7C5F  C1           POP BC
7C60  E1           POP HL
7C61  E5           PUSH HL
7C62  CD 9E 09     CALL 099E
7C65  E1           POP HL
7C66  ED 5B 31 79  LD DE,(7931) ; 1ST-PARAM
7C6A  72           LD (HL),D
7C6B  23           INC HL
7C6C  73           LD (HL),E
7C6D  ED 4B 33 79  LD BC,(7933) ; 2ND-PARAM
7C71  03           INC BC
7C72  03           INC BC
7C73  23           INC HL
7C74  71           LD (HL),C
7C75  23           INC HL
7C76  70           LD (HL),B
7C77  23           INC HL
7C78  36 EA        LD (HL),EA
7C7A  3A 35 79     LD A,(7935)  ; 3RD-PARAM
7C7D  23           INC HL
7C7E  77           LD (HL),A
7C7F  E5           PUSH HL
7C80  D1           POP DE
7C81  13           INC DE
7C82  0B           DEC BC
7C83  0B           DEC BC
7C84  0B           DEC BC
7C85  CB 78        BIT 7,B
7C87  03           INC BC
7C88  20 02        JR NZ,7C8C
7C8A  ED B0        LDIR
7C8C  36 76        LD (HL),76
7C8E  2A 10 40     LD HL,(4010)
7C91  01 19 03     LD BC,0319
7C94  A7           AND A
7C95  ED 42        SBC HL,BC
7C97  22 0C 40     LD (400C),HL
7C9A  18 9A        JR 7C36


; command O (copy memory blocks)

7C9C  CD F7 7B     CALL 7BF7    ; $ORG
7C9F  CD A7 7A     CALL 7AA7
7CA2  2A 33 79     LD HL,(7933) ; 2ND-PARAM
7CA5  ED 4B 31 79  LD BC,(7931) ; 1ST-PARAM
7CA9  A7           AND A
7CAA  ED 42        SBC HL,BC
7CAC  30 10        JR NC,7CBE
7CAE  CD C1 78     CALL 78C1    ; $PRINT
7CB1  27 31 34 28  ; print "BLOCO ILEGAL"
      34 00 2E 31
      2A 2C 26 B1
7CBD  C9           RET
7CBE  E5           PUSH HL
7CBF  C5           PUSH BC
7CC0  E1           POP HL
7CC1  C1           POP BC
7CC2  E5           PUSH HL
7CC3  A7           AND A
7CC4  ED 52        SBC HL,DE
7CC6  30 11        JR NC,7CD9
7CC8  19           ADD HL,DE
7CC9  09           ADD HL,BC
7CCA  A7           AND A
7CCB  ED 52        SBC HL,DE
7CCD  38 0A        JR C,7CD9
7CCF  E1           POP HL
7CD0  09           ADD HL,BC
7CD1  EB           EX DE,HL
7CD2  09           ADD HL,BC
7CD3  EB           EX DE,HL
7CD4  2B           DEC HL
7CD5  1B           DEC DE
7CD6  ED B8        LDDR
7CD8  C9           RET
7CD9  E1           POP HL
7CDA  ED B0        LDIR
7CDC  C9           RET


; routine $AVND (forward for command D)

7CDD  2A 2F 79     LD HL,(792F) ; D-ADDRESS
7CE0  E5           PUSH HL
7CE1  01 08 00     LD BC,0008
7CE4  09           ADD HL,BC
7CE5  22 2F 79     LD (792F),HL ; D-ADDRESS
7CE8  E1           POP HL
7CE9  CD 60 78     CALL 7860    ; $SCRUP
7CEC  CD 02 7B     CALL 7B02    ; $ENDER
7CEF  3A 26 79     LD A,(7926)  ; MFLAG
7CF2  06 08        LD B,08
7CF4  CB 4F        BIT 1,A
7CF6  20 0A        JR NZ,7D02
7CF8  7E           LD A,(HL)
7CF9  CD 3E 78     CALL 783E    ; $BYTE
7CFC  AF           XOR A
7CFD  D7           RST 10
7CFE  23           INC HL
7CFF  10 F7        DJNZ 7CF8
7D01  C9           RET
7D02  7E           LD A,(HL)
7D03  CB 77        BIT 6,A
7D05  28 02        JR Z,7D09
7D07  3E 1B        LD A,1B
7D09  D7           RST 10
7D0A  AF           XOR A
7D0B  D7           RST 10
7D0C  D7           RST 10
7D0D  23           INC HL
7D0E  10 F2        DJNZ 7D02
7D10  C9           RET


; routine $RTRD (backward for command D)

7D11  2A 2F 79     LD HL,(792F) ; D-ADDRESS
7D14  01 08 00     LD BC,0008
7D17  A7           AND A
7D18  ED 42        SBC HL,BC
7D1A  22 2F 79     LD (792F),HL ; D-ADDRESS
7D1D  CD 79 78     CALL 7879    ; $SCRDN
7D20  0E B0        LD C,B0
7D22  A7           AND A
7D23  ED 42        SBC HL,BC
7D25  18 C5        JR 7CEC


; command D (display memory)

7D27  AF           XOR A
7D28  D7           RST 10
7D29  CD 52 7A     CALL 7A52    ; $CURSOR
7D2C  B7           OR A
7D2D  28 07        JR Z,7D36
7D2F  CD 9E 7A     CALL 7A9E    ; $VALDE
7D32  EB           EX DE,HL
7D33  22 2F 79     LD (792F),HL ; D-ADDRESS
7D36  CD 60 78     CALL 7860    ; $SCRUP
7D39  CD DD 7C     CALL 7CDD    ; $AVND
7D3C  CD D3 78     CALL 78D3    ; $KEY
7D3F  B7           OR A
7D40  C8           RET Z
7D41  FE 30        CP 30
7D43  28 F4        JR Z,7D39
7D45  FE 2F        CP 2F
7D47  CC 11 7D     CALL Z,7D11  ; $RTRD
7D4A  18 F0        JR 7D3C


; command A (assign numeric base)

7D4C  AF           XOR A
7D4D  D7           RST 10
7D4E  CD 52 7A     CALL 7A52    ; $CURSOR
7D51  21 AD 7A     LD HL,7AAD
7D54  FE 2D        CP 2D
7D56  28 0D        JR Z,7D65
7D58  FE 29        CP 29
7D5A  20 12        JR NZ,7D6E
7D5C  36 28        LD (HL),28
7D5E  23           INC HL
7D5F  36 2D        LD (HL),2D
7D61  23           INC HL
7D62  36 00        LD (HL),00
7D64  C9           RET
7D65  36 20        LD (HL),20
7D67  23           INC HL
7D68  36 2E        LD (HL),2E
7D6A  23           INC HL
7D6B  36 23        LD (HL),23
7D6D  C9           RET
7D6E  CD C1 78     CALL 78C1    ; $PRINT
7D71  0D 14 29 00  ; print "$=D OU $=H"
      34 3A 00 0D
      14 AD
7D7B  C9           RET


; routine $ARQ (store registers into buffer)

7D7C  22 38 79     LD (7938),HL
7D7F  F5           PUSH AF
7D80  E1           POP HL
7D81  22 36 79     LD (7936),HL
7D84  ED 53 3A 79  LD (793A),DE
7D88  ED 43 3C 79  LD (793C),BC
7D8C  C9           RET


; routine $RCP (recover registers from buffer)

7D8D  2A 36 79     LD HL,(7936)
7D90  E5           PUSH HL
7D91  F1           POP AF
7D92  2A 38 79     LD HL,(7938)
7D95  ED 5B 3A 79  LD DE,(793A)
7D99  ED 4B 3C 79  LD BC,(793C)
7D9D  C9           RET


; command N (change values of register pairs)

7D9E  2A 0E 40     LD HL,(400E)
7DA1  36 04        LD (HL),04
7DA3  CD D3 78     CALL 78D3    ; $KEY
7DA6  D7           RST 10
7DA7  CD AA 78     CALL 78AA    ; $CONT
7DAA  F5           PUSH AF
7DAB  AF           XOR A
7DAC  D7           RST 10
7DAD  CD 52 7A     CALL 7A52    ; $CURSOR
7DB0  B7           OR A
7DB1  CA 4A 7A     JP Z,7A4A
7DB4  01 04 15     LD BC,1504
7DB7  CD A1 7A     CALL 7AA1
7DBA  F1           POP AF
7DBB  EB           EX DE,HL
7DBC  FE 26        CP 26
7DBE  20 03        JR NZ,7DC3
7DC0  22 36 79     LD (7936),HL
7DC3  FE 2D        CP 2D
7DC5  20 03        JR NZ,7DCA
7DC7  22 38 79     LD (7938),HL
7DCA  FE 29        CP 29
7DCC  20 03        JR NZ,7DD1
7DCE  22 3A 79     LD (793A),HL
7DD1  FE 27        CP 27
7DD3  20 03        JR NZ,7DD8
7DD5  22 3C 79     LD (793C),HL
7DD8  FE 33        CP 33
7DDA  20 0C        JR NZ,7DE8
7DDC  22 36 79     LD (7936),HL
7DDF  22 38 79     LD (7938),HL
7DE2  22 3A 79     LD (793A),HL
7DE5  22 3C 79     LD (793C),HL


; command H (print registers values)

7DE8  CD C1 78     CALL 78C1    ; $PRINT
7DEB  00 26 2B 00  ; registers header
      00 00 2D 31
      00 00 00 29
      2A 00 00 00
      27 28 00 00
      00 2B 14 00
      38 3F 16 26
      16 35 33 A8
7E0B  CD 60 78     CALL 7860    ; $SCRUP
7E0E  06 04        LD B,04
7E10  21 37 79     LD HL,7937
7E13  7E           LD A,(HL)
7E14  CD 3E 78     CALL 783E    ; $BYTE
7E17  2B           DEC HL
7E18  7E           LD A,(HL)
7E19  CD 3E 78     CALL 783E    ; $BYTE
7E1C  AF           XOR A
7E1D  D7           RST 10
7E1E  23           INC HL
7E1F  23           INC HL
7E20  23           INC HL
7E21  10 F0        DJNZ 7E13
7E23  06 04        LD B,04
7E25  D7           RST 10
7E26  10 FD        DJNZ 7E25
7E28  3A 36 79     LD A,(7936)
7E2B  06 08        LD B,08
7E2D  4F           LD C,A
7E2E  CB 11        RL C
7E30  30 04        JR NC,7E36
7E32  3E 1D        LD A,1D
7E34  18 02        JR 7E38
7E36  3E 1C        LD A,1C
7E38  D7           RST 10
7E39  10 F3        DJNZ 7E2E
7E3B  C9           RET


; command F (fill block with char)

7E3C  CD F7 7B     CALL 7BF7    ; $ORG
7E3F  2A 31 79     LD HL,(7931) ; 1ST-PARAM
7E42  3A 35 79     LD A,(7935)  ; 3RD-PARAM
7E45  77           LD (HL),A
7E46  CD 4B 7E     CALL 7E4B    ; $PROX
7E49  18 FA        JR 7E45


; routine $PROX (update pointer HL inside a block)

7E4B  23           INC HL
7E4C  EB           EX DE,HL
7E4D  2A 33 79     LD HL,(7933) ; 2ND-PARAM
7E50  37           SCF
7E51  ED 52        SBC HL,DE
7E53  EB           EX DE,HL
7E54  D0           RET NC
7E55  E1           POP HL
7E56  C9           RET


; lost byte

7E57  00           NOP


; routine $SAVE (save to tape)

7E58  CD 23 0F     CALL 0F23
7E5B  06 60        LD B,60
7E5D  C5           PUSH BC
7E5E  CD B7 78     CALL 78B7    ; $TEMPO
7E61  C1           POP BC
7E62  10 F9        DJNZ 7E5D
7E64  2A 31 79     LD HL,(7931) ; 1ST-PARAM
7E67  CD 6F 7E     CALL 7E6F
7E6A  CD 4B 7E     CALL 7E4B    ; $PROX
7E6D  18 F8        JR 7E67
7E6F  5E           LD E,(HL)
7E70  37           SCF
7E71  CB 13        RL E
7E73  C8           RET Z
7E74  9F           SBC A,A
7E75  E6 02        AND 02
7E77  C6 01        ADD A,01
7E79  4F           LD C,A
7E7A  D3 FF        OUT (FF),A
7E7C  06 23        LD B,23
7E7E  10 FE        DJNZ 7E7E
7E80  CD 46 0F     CALL 0F46
7E83  30 D0        JR NC,7E55
7E85  06 1E        LD B,1E
7E87  10 FE        DJNZ 7E87
7E89  0D           DEC C
7E8A  20 EE        JR NZ,7E7A
7E8C  A7           AND A
7E8D  10 FD        DJNZ 7E8C
7E8F  18 E0        JR 7E71


; routine $LOAD (read from tape)

7E91  CD 23 0F     CALL 0F23
7E94  2A 31 79     LD HL,(7931) ; 1ST-PARAM
7E97  50           LD D,B
7E98  CD A1 7E     CALL 7EA1
7E9B  71           LD (HL),C
7E9C  CD 4B 7E     CALL 7E4B    ; $PROX
7E9F  18 F6        JR 7E97
7EA1  0E 01        LD C,01
7EA3  06 00        LD B,00
7EA5  3E 7F        LD A,7F
7EA7  DB FE        IN A,(FE)
7EA9  D3 FF        OUT (FF),A
7EAB  1F           RRA
7EAC  30 A7        JR NC,7E55
7EAE  17           RLA
7EAF  17           RLA
7EB0  30 F3        JR NC,7EA5
7EB2  D5           PUSH DE
7EB3  1E 31        LD E,31
7EB5  06 0E        LD B,0E
7EB7  1D           DEC E
7EB8  DB FE        IN A,(FE)
7EBA  17           RLA
7EBB  CB 7B        BIT 7,E
7EBD  7B           LD A,E
7EBE  38 F5        JR C,7EB5
7EC0  10 F5        DJNZ 7EB7
7EC2  D1           POP DE
7EC3  20 04        JR NZ,7EC9
7EC5  FE 56        CP 56
7EC7  30 DA        JR NC,7EA3
7EC9  3F           CCF
7ECA  CB 11        RL C
7ECC  30 D5        JR NC,7EA3
7ECE  C9           RET


; routine $VAG (implement high speed save)

7ECF  21 76 7E     LD HL,7E76
7ED2  36 02        LD (HL),02
7ED4  23           INC HL
7ED5  23           INC HL
7ED6  36 01        LD (HL),01
7ED8  21 B4 7E     LD HL,7EB4
7EDB  36 31        LD (HL),31
7EDD  23           INC HL
7EDE  23           INC HL
7EDF  36 0E        LD (HL),0E
7EE1  C9           RET


; routine $VNG (implement normal speed save)

7EE2  21 76 7E     LD HL,7E76
7EE5  36 05        LD (HL),05
7EE7  23           INC HL
7EE8  23           INC HL
7EE9  36 04        LD (HL),04
7EEB  21 B4 7E     LD HL,7EB4
7EEE  36 94        LD (HL),94
7EF0  23           INC HL
7EF1  23           INC HL
7EF2  36 1A        LD (HL),1A
7EF4  C9           RET


; routine $IVG (organize parameters and speed for I and J)

7EF5  CD F7 7B     CALL 7BF7    ; $ORG
7EF8  3A 26 79     LD A,(7926)  ; MFLAG
7EFB  CB 7F        BIT 7,A
7EFD  C4 CF 7E     CALL NZ,7ECF ; $VAG
7F00  CC E2 7E     CALL Z,7EE2  ; $VNG
7F03  C9           RET


; command I (save block)

7F04  CD F5 7E     CALL 7EF5    ; $IVG
7F07  CD 58 7E     CALL 7E58    ; $SAVE
7F0A  C3 36 7C     JP 7C36


; command J (load block)

7F0D  CD F5 7E     CALL 7EF5    ; $IVG
7F10  CD 91 7E     CALL 7E91    ; $LOAD
7F13  18 F5        JR 7F0A


; command L (remove BREAKPOINT)

7F15  AF           XOR A
7F16  D7           RST 10
7F17  2A 28 79     LD HL,(7928) ; BREAKPOINT
7F1A  CD 02 7B     CALL 7B02    ; $ENDER
7F1D  21 27 79     LD HL,7927   ; SFLAG
7F20  CB BE        RES 7,(HL)
7F22  C9           RET


; command K (implement BREAKPOINT)

7F23  AF           XOR A
7F24  D7           RST 10
7F25  CD 52 7A     CALL 7A52    ; $CURSOR
7F28  B7           OR A
7F29  28 07        JR Z,7F32
7F2B  CD 9E 7A     CALL 7A9E    ; $VALDE
7F2E  ED 53 28 79  LD (7928),DE ; BREAKPOINT
7F32  21 27 79     LD HL,7927   ; SFLAG
7F35  CB FE        SET 7,(HL)
7F37  C9           RET


; command G (execute machine language routine)

7F38  AF           XOR A
7F39  D7           RST 10
7F3A  CD 52 7A     CALL 7A52    ; $CURSOR
7F3D  B7           OR A
7F3E  C8           RET Z
7F3F  CD 9E 7A     CALL 7A9E    ; $VALDE
7F42  21 69 7F     LD HL,7F69
7F45  E5           PUSH HL
7F46  D5           PUSH DE
7F47  21 27 79     LD HL,7927   ; SFLAG
7F4A  CB 7E        BIT 7,(HL)
7F4C  28 17        JR Z,7F65
7F4E  2A 28 79     LD HL,(7928) ; BREAKPOINT
7F51  11 2A 79     LD DE,792A
7F54  06 03        LD B,03
7F56  7E           LD A,(HL)
7F57  12           LD (DE),A
7F58  23           INC HL
7F59  13           INC DE
7F5A  10 FA        DJNZ 7F56
7F5C  2B           DEC HL
7F5D  36 7F        LD (HL),7F
7F5F  2B           DEC HL
7F60  36 69        LD (HL),69
7F62  2B           DEC HL
7F63  36 C3        LD (HL),C3
7F65  CD 8D 7D     CALL 7D8D    ; $RCP
7F68  C9           RET
7F69  CD 7C 7D     CALL 7D7C    ; $ARQ
7F6C  21 27 79     LD HL,7927   ; SFLAG
7F6F  CB 7E        BIT 7,(HL)
7F71  28 10        JR Z,7F83
7F73  CB BE        RES 7,(HL)
7F75  11 2A 79     LD DE,792A
7F78  2A 28 79     LD HL,(7928) ; BREAKPOINT
7F7B  06 03        LD B,03
7F7D  1A           LD A,(DE)
7F7E  77           LD (HL),A
7F7F  23           INC HL
7F80  13           INC DE
7F81  10 FA        DJNZ 7F7D
7F83  C3 36 7C     JP 7C36


; command C (load operational module)

7F86  CD E2 7E     CALL 7EE2    ; $VNG
7F89  21 00 6E     LD HL,6E00
7F8C  22 31 79     LD (7931),HL ; 1ST-PARAM
7F8F  21 3C 78     LD HL,783C
7F92  22 33 79     LD (7933),HL ; 2ND-PARAM
7F95  06 08        LD B,08
7F97  21 64 79     LD HL,7964
7F9A  36 34        LD (HL),34
7F9C  23           INC HL
7F9D  36 7A        LD (HL),7A
7F9F  23           INC HL
7FA0  10 F8        DJNZ 7F9A
7FA2  21 27 79     LD HL,7927   ; SFLAG
7FA5  CB 96        RES 2,(HL)
7FA7  CD 91 7E     CALL 7E91    ; $LOAD
7FAA  21 3A 78     LD HL,783A
7FAD  22 33 79     LD (7933),HL ; 2ND-PARAM
7FB0  21 00 6E     LD HL,6E00
7FB3  01 00 00     LD BC,0000
7FB6  CD C9 7F     CALL 7FC9    ; $SOMA
7FB9  2A 3A 78     LD HL,(783A)
7FBC  A7           AND A
7FBD  ED 42        SBC HL,BC
7FBF  20 05        JR NZ,7FC6
7FC1  21 27 79     LD HL,7927   ; SFLAG
7FC4  CB D6        SET 2,(HL)
7FC6  C3 EE 79     JP 79EE


; routine $SOMA (calculate sum of bytes of a block)

7FC9  16 00        LD D,00
7FCB  5E           LD E,(HL)
7FCC  EB           EX DE,HL
7FCD  09           ADD HL,BC
7FCE  E5           PUSH HL
7FCF  C1           POP BC
7FD0  EB           EX DE,HL
7FD1  CD 4B 7E     CALL 7E4B    ; $PROX
7FD4  18 F3        JR 7FC9


; command P (sum of a block)

7FD6  CD F7 7B     CALL 7BF7    ; $ORG
7FD9  2A 31 79     LD HL,(7931) ; 1ST-PARAM
7FDC  01 00 00     LD BC,0000
7FDF  CD C9 7F     CALL 7FC9    ; $SOMA
7FE2  C5           PUSH BC
7FE3  01 10 15     LD BC,1510
7FE6  CD F5 08     CALL 08F5
7FE9  3E 16        LD A,16
7FEB  D7           RST 10
7FEC  D7           RST 10
7FED  D7           RST 10
7FEE  3E 12        LD A,12
7FF0  D7           RST 10
7FF1  E1           POP HL
7FF2  C3 0E 7B     JP 7B0E


; END OF LISTING - This is part of TKPAK001.ZIP and cannot be sold separately!

